parcres <- function(fit, n)
#
#        kresl dvojici diagram
#        fit ... model lm
#        n   ... poad promnn v modelu
#
{
        trms <- predict(fit, type = "terms")
        xjname <- dimnames(trms)[[2]][n]
        xj <- fit$model[,xjname]
        yname <- deparse(fit$terms[[2]])
	y <- fit$model[,yname]
        pares <- trms[, n] + resid(fit) + mean(y)
	par(mfrow=c(1,2))
	yrange <- range(c(y,pares))
        plot(xj, y, xlab = xjname, ylab = yname, 
                pch = 16, ylim=yrange)
        abline(lm(y~xj))
        plot(xj, pares, xlab = xjname, ylab = "partial residual", 
                pch = 16, ylim=yrange)
        abline(lm(pares~xj))
	par(mfrow=c(1,1))
        invisible(list(pares=pares))
}
