#
#	Regrese, 5. kapitola identifikace
#
rm(list=ls(all=TRUE))
mpInv <- function(X,eps=sqrt(.Machine$double.eps)){
   a <- svd(X)
   nn <- a$d>eps*a$d[1]
   if (any(nn)) a$v[,nn]%*%(t(a$u[,nn])/a$d[nn]) else t(X)*0
}
#
data(Med)
attach(Med)
X <- cbind(1,model.matrix(~Misto-1))
round(bPlus <- as.vector(mpInv(X)%*%lnCu),3)
#
sqrt(crossprod(bPlus))
#
a <- lm(lnCu~Misto)
sqrt(crossprod(coef(a)))
#
D <- rbind(X,c(0,1,0,0,0,0))
round(as.vector(b1 <- solve(t(D)%*%D)%*%t(X)%*%lnCu),3)
summary(a)
detach(Med)
#
