#
#	Regrese - 12. kapitola, logistick regrese
#
rm(list=ls(all=TRUE))
data(Kojeni)
print(kt <- xtabs(~Plan+Koj24,data=Kojeni))
print(b0 <- log(kt[1,2]/kt[1,1]))
print(b1 <- log(kt[1,1]*kt[2,2]/(kt[1,2]*kt[2,1])))
print(sqrt(v11 <- sum(1/kt)))
print(z <- b1/sqrt(v11));print(2*(1-pnorm(abs(z))))
#
summary(Koj24.Plan <- glm(Koj24~Plan,family="binomial",data=Kojeni))
#
anova(Koj24.Plan,test="Chisq")
#
chisq.test(kt,correct=F)
fisher.test(kt)
summary(Koj24.vek.m <- glm(Koj24~vek.m,family="binomial",data=Kojeni))
exp(coef(Koj24.vek.m))
#
Koj24.Vzdelani<-glm(Koj24~Vzdelani,family="binomial",data=Kojeni)
anova(Koj24.Vzdelani,test="Chisq")
#	koeficienty detemrminace
source("logistR2.R")
nagel.R2(Koj24.Vzdelani,Nagelkerke=FALSE)
nagel.R2(Koj24.Vzdelani)
mcfadden.R2(Koj24.Vzdelani)
#
print(nn <- table(Kojeni$Koj24))
D0 <- -2*(nn[1]*log(nn[1]/sum(nn))+nn[2]*log(nn[2]/sum(nn)))
names(D0) <- NULL; D0
R2.max <- 1-exp(-D0/sum(nn))
names(R2.max) = NULL; R2.max
chisq.test(Kojeni$Vzdelani,Kojeni$Koj24)
###chisq.test(xtabs(~Vzdelani+Koj24,data=Kojeni))
#
Koj24.vek.m<-glm(Koj24~vek.m,family="binomial",data=Kojeni)
summary(Koj24.vek.m)
nagel.R2(Koj24.vek.m)
mcfadden.R2(Koj24.vek.m)
#
#	jet graf zvislosti na vku
xx <- seq(15,50,length=101)
yy <- predict(Koj24.vek.m,newdata=list(vek.m=xx),type="response")
pp <- predict(Koj24.vek.m,newdata=list(vek.m=c(20,30)),type="response")
plot(yy~xx,type="l",ylim=0:1,xlab="vk matky",ylab="pst")
abline(v=c(20,30),h=pp,lty=3)
print(pp)
anova(Koj24.vek.m,test="Chisq")
#
