#
nagel.R2 <- function(a,Nagelkerke=T){
#  vpoet Nagelkerkeho zobecnnho koeficientu 
#  determinace
#  a   vsledek poit glm
D1 <- deviance(a)
D0 <- a$null.deviance
n <- length(residuals(a))
R2 <- 1-exp((D1-D0)/n)
R2.max <- 1-exp(-D0/n)
R2.Nagel <- R2/R2.max
R2.out <- ifelse(Nagelkerke,R2.Nagel,R2)
return(R2.out)
}
#
#	McFaddenv koeficient
mcfadden.R2 <- function(a){
#
D1 <- deviance(a)
D0 <- a$null.deviance
R2.out <- 1-D1/D0
return(R2.out)
}
