obr15.2 <- function(soubor="../obr15_2N.ps",x1=1,x2=3,
	theta=seq(0,1,length=101),thetaStar=.5,
	thetaSeq=seq(min(theta),max(theta),length=7)){
#	modifikace, aby byla v bodu dotyku stejn rychlost
#	kresl dvojici obrzk
primkaTB <- matrix(c(fceT0(thetaStar,x1=x1,x2=x2)),length(thetaSeq),2,byrow=TRUE)+
	c(thetaSeq-thetaStar)%o%c(fceT1(thetaStar,x1=x1,x2=x2))
betaStar <- exp(thetaStar)
betaSeq <- betaStar+(thetaSeq-thetaStar)*Bprime(thetaStar)
minB <- min(c(exp(theta),betaSeq))
maxB <- max(c(exp(theta),betaSeq))
beta <- seq(minB,maxB,length=101)
if (min(beta)<exp(min(theta))) theta<-log(beta)
###betaSeq <- exp(thetaSeq)
psGraf(soubor)
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1)
#	rozsah y
fceMin <- fceT0(min(theta),x1=x1,x2=x2)
fceMax <- fceT0(max(theta),x1=x1,x2=x2)
primkaT <- matrix(c(fceT0(thetaStar,x1=x1,x2=x2)),length(thetaSeq),2,byrow=TRUE)+
	c(thetaSeq-thetaStar)%o%c(fceT1(thetaStar,x1=x1,x2=x2))
primkaB <- matrix(c(fceB0(betaStar,x1=x1,x2=x2)),length(betaSeq),2,byrow=TRUE)+
	c(betaSeq-betaStar)%o%c(fceB1(betaStar,x1=x1,x2=x2))
xlim <- range(fceMin[1],fceMax[1],primkaT[,1],primkaB[,1])
ylim <- range(fceMin[2],fceMax[2],primkaT[,2],primkaB[,2])
#	obrzek pro theta
plot(fceT0(theta,x1=x1,x2=x2),xlab=expression(y[1]),ylab=expression(y[2]),
	xlim=xlim,ylim=ylim,type="l")
points(fceT0(thetaSeq,x1=x1,x2=x2),pch="+",cex=1.5)
#	ten pmka
derStar <- fceT1(thetaStar); fceStar <- fceT0(thetaStar)
smernice <- derStar[2]/derStar[1]
absClen <- fceStar[2]-smernice*fceStar[1]
abline(absClen,smernice)
#	body na pmce
points(primkaT,pch="+",cex=1.5)
#	obrzek pro beta
plot(fceB0(beta,x1=x1,x2=x2),xlab=expression(y[1]),ylab=expression(y[2]),
	xlim=xlim,ylim=ylim,type="l")
points(fceB0(betaSeq,x1=x1,x2=x2),pch="+",cex=1.5)
#	ten pmka
derStar <- fceB1(betaStar); fceStar <- fceB0(betaStar)
smernice <- derStar[2]/derStar[1]
absClen <- fceStar[2]-smernice*fceStar[1]
abline(absClen,smernice)
#	body na pmce
points(primkaB,pch="+",cex=1.5)
#	ukonen
par(opar)
dev.off()
##return(list(x1=x1,x2=x2,thetaStar=thetaStar,betaStar=betaStar))
return(list(primkaT,primkaB))
}
#
#	pro zajmavost vetn kvadratick aproximace
obr15.2K <- function(soubor="../obr15_2K.ps",x1=1,x2=3,
	theta=seq(0,1,length=101),thetaStar=.5,
	thetaSeq=seq(min(theta),max(theta),length=7)){
#	kresl dvojici obrzk
beta <- exp(theta)
betaStar <- exp(thetaStar)
betaSeq <- seq(exp(min(theta)),exp(max(theta)),length=length(thetaSeq))
psGraf(soubor)
opar <- par(mfrow = c(1,2), oma = c(1.1, 0, 1.1, 0), las = 1)
#	rozsah y
fceMin <- fceT0(min(theta),x1=x1,x2=x2)
fceMax <- fceT0(max(theta),x1=x1,x2=x2)
primkaT <- matrix(c(fceT0(thetaStar,x1=x1,x2=x2)),length(thetaSeq),2,byrow=TRUE)+
	c(thetaSeq-thetaStar)%o%c(fceT1(thetaStar,x1=x1,x2=x2))
primkaB <- matrix(c(fceB0(betaStar,x1=x1,x2=x2)),length(betaSeq),2,byrow=TRUE)+
	c(betaSeq-betaStar)%o%c(fceB1(betaStar,x1=x1,x2=x2))
#	kvadratick aproximace
kubikT <- matrix(c(fceT0(thetaStar,x1=x1,x2=x2)),length(thetaSeq),2,byrow=TRUE)+
	c(thetaSeq-thetaStar)%o%c(fceT1(thetaStar,x1=x1,x2=x2))+
	c(thetaSeq-thetaStar)^2%o%c(fceT2(thetaStar,x1=x1,x2=x2))/2
kubikB <- matrix(c(fceB0(betaStar,x1=x1,x2=x2)),length(betaSeq),2,byrow=TRUE)+
	c(betaSeq-betaStar)%o%c(fceB1(betaStar,x1=x1,x2=x2))+
	c(betaSeq-betaStar)^2%o%c(fceB2(betaStar,x1=x1,x2=x2))/2
#
xlim <- range(fceMin[1],fceMax[1],primkaT[,1],primkaB[,1])
ylim <- range(fceMin[2],fceMax[2],primkaT[,2],primkaB[,2])
#	obrzek pro theta
plot(fceT0(theta,x1=x1,x2=x2),xlab=expression(y[1]),ylab=expression(y[2]),
	xlim=xlim,ylim=ylim,type="l")
points(fceT0(thetaSeq,x1=x1,x2=x2),pch="+",cex=1.5)
points(kubikT,pch="*",col=2)
#	ten pmka
derStar <- fceT1(thetaStar); fceStar <- fceT0(thetaStar)
smernice <- derStar[2]/derStar[1]
absClen <- fceStar[2]-smernice*fceStar[1]
abline(absClen,smernice)
#	body na pmce
points(primkaT,pch="+",cex=1.5)
#	obrzek pro beta
plot(fceB0(beta,x1=x1,x2=x2),xlab=expression(y[1]),ylab=expression(y[2]),
	xlim=xlim,ylim=ylim,type="l")
points(fceB0(betaSeq,x1=x1,x2=x2),pch="+",cex=1.5)
points(kubikT,pch="*",col=2)
#	ten pmka
derStar <- fceB1(betaStar); fceStar <- fceB0(betaStar)
smernice <- derStar[2]/derStar[1]
absClen <- fceStar[2]-smernice*fceStar[1]
abline(absClen,smernice)
#	body na pmce
points(primkaB,pch="+",cex=1.5)
#	ukonen
par(opar)
dev.off()
return(list(x1=x1,x2=x2,thetaStar=thetaStar,betaStar=betaStar))
}
#
#
#	pomocn funkce
#
#	regrese, kapitola Parametrizace v NLR
fceT0 <- function(theta,x1=1,x2=3){
#       vektor funkcnich hodnot f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(exp(x1*theta[i]),exp(x2*theta[i])))
OUT
}
fceT1 <- function(theta,x1=1,x2=3){
#       vektor prvnich derivaci f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(x1*exp(x1*theta[i]),x2*exp(x2*theta[i])))
OUT
}
fceT2 <- function(theta,x1=1,x2=3){
#       vektor druhych derivaci f(theta)
OUT <- NULL
for (i in 1:length(theta)) 
        OUT <- rbind(OUT,c(x1^2*exp(x1*theta[i]),x2^2*exp(x2*theta[i])))
OUT
}
fceB0 <- function(beta,x1=1,x2=3){
#       vektor funkcnich hodnot f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(beta[i]^x1,beta[i]^x2))
OUT
}
fceB1 <- function(beta,x1=1,x2=3){
#       vektor prvnich derivaci f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(x1*beta[i]^(x1-1),x2*beta[i]^(x2-1)))
OUT
}
fceB2 <- function(beta,x1=1,x2=3){
#       vektor druhych derivaci f(beta)
OUT <- NULL
for (i in 1:length(beta)) 
        OUT <- rbind(OUT,c(x1*(x1-1)*beta[i]^(x1-2),x2*(x2-1)*beta[i]^(x2-2)))
OUT
}
fceT2T <- function(theta,x1=1,x2=3){
#       prmt druhch derivac do nadroviny
#       predpoklada skalarni theta
OUT <- c(crossprod(c(fceT1(theta,x1=x1,x2=x2)),c(fceT2(theta,x1=x1,x2=x2))))/
        c(crossprod(c(fceT1(theta,x1=x1,x2=x2))))*fceT1(theta,x1=x1,x2=x2)
OUT
}
fceT2N <- function(theta,x1=1,x2=3){
#       prmt kolm na tecnou nadrovinu
#       predpoklada sklarni theta
OUT <- fceT2(theta,x1=x1,x2=x2)-fceT2T(theta,x1=x1,x2=x2)
OUT
}

fceB2N <- function(beta,x1=1,x2=3){
#       prmt kolm na tecnou nadrovinu
#       predpoklada sklarni theta
OUT <- fceB2(beta,x1=x1,x2=x2)-fceB2T(beta,x1=x1,x2=x2)
OUT
}
fceB2T <- function(beta,x1=1,x2=3){
#       prmt druhch derivac do nadroviny
#       predpoklada skalarni theta
OUT <- c(crossprod(c(fceB1(beta,x1=x1,x2=x2)),c(fceB2(beta,x1=x1,x2=x2))))/
        c(crossprod(c(fceB1(beta,x1=x1,x2=x2))))*fceB1(beta,x1=x1,x2=x2)
OUT
}
#	derivace beta podle theta
Bprime <- function(theta)  {exp(theta)}


