#
#	Regrese: 2. kapitola Model
#
rm(list=ls(all=TRUE))
data(Hosi0)
summary(lm(por.hmot~por.del,data=Hosi0))
#
data(Iq)
summary(a7 <- lm(iq~divka+zn7,data=Iq))
summary(lm(iq~divka+zn8,data=Iq))
summary(lm(iq~divka,data=Iq))
#
library(ellipse)
plot(ellipse(a7,c(2,3)),type="l")
points(coef(a7)[2],coef(a7)[3],pch=18)
abline(v=confint(a7)[2,],lty=2)
abline(h=confint(a7)[3,],lty=2)
#
data(Hlavy)
x <- Hlavy$t-27
summary(aw <- lm(y~x+I(x^2)+x:(x>=0)+I(x^2):(x>=0),weights=n,data=Hlavy))
summary(lm(y~x+I(x^2)+x:(x>=0)+I(x^2):(x>=0),data=Hlavy))
summary(a2w <- lm(y~x+I(x^2)+I(x^2):(x>=0),weights=n,data=Hlavy))
plot(y~t,data=Hlavy)
tt <- seq(min(Hlavy$t),max(Hlavy$t),length=101)
lines(tt,predict(aw,newdata=data.frame(x=tt-27)),lty=2)
lines(tt,predict(a2w,newdata=data.frame(x=tt-27)))
legend("bottomright",legend=c("spojit","hladk"),lty=2:1)
abline(v=27,lty=3)
